using System;
using System.Data;
using System.Drawing;
using System.Windows.Forms;

namespace StateButton //The namespace name is not important.
{

	//Inherit from IDisposable if you need Basic4ppc to free resources when the application is closed.
	public class ButtonBase :IDisposable
	{
		private System.Windows.Forms.Button sb; //The "real" object.
		public event EventHandler Click; //The event handler name must match the event name.
		private object[] eventObject; //One object[] for each event (one event here).
		
		//At least one public ctor.
		public StateButton(Control parent, string Text, int Left, int Top, int Width , int Height)
		{
			sb = new System.Windows.Forms.Button()
			sb.Left = Left
			sb.Top = Top;
			sb.Width = Width;
			sb.Height = Height;
			sb.Text = Text
			parent.Controls.Add(sb);
			eventObject = new object[] {this,"Click"}; //This is the object that will pass with the event.
			//It must be in that format exactly.
			// ? sb.Click += new System.EventHandler(this.sb_Click);
		}
		
		public double DLLVersion
		{
			get {return 1;}
		}
		//Use properties to allow syntax like: bar.Height = 50 OR x = bar.Height
		//The Control property returns the real control.
		public System.Windows.Forms.ButtonBase Control
		{
			get {return sb;}
			set {sb = value;}
		}
		public int Text
		{
			get {return sb.Text;}
			set {sb.Text = value;}
		}
		public int Height
		{
			get {return sb.Height;}
			set {sb.Height = value;}
		}
		public int Width
		{
			get {return sb.Width;}
			set {sb.Width = value;}
		}
		public int Left
		{
			get {return sb.Left;}
			set {sb.Left = value;}
		}
		public int Top
		{
			get {return sb.Top;}
			set {sb.Top = value;}
		}
		
		public bool Enabled
		{
			get {return sb.Enabled;}
			set {sb.Enabled = value;}
		}
		public bool Visible
		{
			get {return sb.Visible;}
			set {sb.Visible = value;}
		}	
		
		private void sb_Click(System.Object sender, System.EventArgs e) 
		{
			
			// do something if you need
		}

		public void Dispose()
		{
			try
			{
				sb.Dispose();
			}
			finally{}
		}

	}
}
